SystemOrganization addCategory: #'iStoaXP-Gde1'!

Etayage subclass: #EtayageNumber1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber1 commentStamp: '<historical>' prior: 0!
Compare two collections with quantities bellow 5.!

!EtayageNumber1 class methodsFor: 'accessing' stamp: 'HilaireFernandes 5/28/2014 17:16'!
description
	^ 'Compare two collections with less than 5 elements.' translated! !

!EtayageNumber1 class methodsFor: 'accessing' stamp: 'HilaireFernandes 5/18/2014 11:55'!
iconNameOrMorph
	^ Path * 'misc' / 'bag.png'! !

!EtayageNumber1 class methodsFor: 'accessing' stamp: 'HilaireFernandes 1/22/2014 20:03'!
myCategory
	^ 'Numbers - Compare collections' translated! !

!EtayageNumber1 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/17/2014 16:13'!
glassEqual: a and: b
"generate proposal token a, token b, a = b"
	^ Array 
		with: (Stoa table addAll: a glass, b plate) 
		with: a = b! !

!EtayageNumber1 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/17/2014 16:14'!
glassMinor: a and: b
"generate proposal token a, token b, a < b"
	^ Array 
		with: (Stoa table addAll: a glass, b plate) 
		with: a < b! !

!EtayageNumber1 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/17/2014 16:14'!
glassSuperior: a and: b
"generate proposal token a, token b, a > b"
	^ Array 
		with: (Stoa table addAll: a glass, b plate) 
		with: a > b! !

!EtayageNumber1 methodsFor: 'step creation' stamp: 'HilaireFernandes 10/24/2014 18:12'!
instanciateStep1
	|  quizData n activity |
	quizData := OrderedCollection new.
	quizData add: (self tokenEqual:  (n := 5 atRandom) and: n);
		add: (self tokenEqual: 2 + 3 atRandom and: 2 atRandom);
		add: (self tokenEqual: 2 atRandom and: 2 + 3 atRandom);
		add: (self tokenEqual: (n := 4  atRandom) and: n).
	activity :=  QuizMorph 
		illustration: (Stoa bag addAll: (n := 4 atRandom) redBall, n greenBall)
		proposals:  quizData. 
		
	question := 'Follow the example and select the bags containing the same number of red balls and green balls.' translated.
	^ EtayageStep 
		board: PluggableBoard  
		method: #question:activity:isSuccess:showErrors:showSolution:
		arguments: {
			question. 
			activity.
			[activity testSuccessAnswer].
			[activity showErrors].
			[activity showSolution]}! !

!EtayageNumber1 methodsFor: 'step creation' stamp: 'HilaireFernandes 10/24/2014 18:12'!
instanciateStep2
	| activity quizData n|

	quizData := OrderedCollection new.
	quizData add: (self tokenSuperior: 2 + 3 atRandom and: 2 atRandom);
		add: (self tokenSuperior: 3 + 2 atRandom and: 3 atRandom);
		add: (self tokenSuperior: 2 atRandom and: 2 + 3 atRandom);
		add: (self tokenSuperior: (n := 5 atRandom) and: n).
	activity :=  QuizMorph 
		illustration: (Stoa bag addAll: 3 redBall, 1 greenBall)
		proposals:  quizData. 

	question := 'Follow the example and select the bags containing more red balls than green balls.' translated.
	^ EtayageStep 
		board: PluggableBoard  
		method: #question:activity:isSuccess:showErrors:showSolution:
		arguments: {
			question. 
			activity.
			[activity testSuccessAnswer].
			[activity showErrors].
			[activity showSolution]}! !

!EtayageNumber1 methodsFor: 'step creation' stamp: 'HilaireFernandes 10/24/2014 18:12'!
instanciateStep3
	| activity quizData n|
	quizData := OrderedCollection new.
	quizData add: (self tokenMinor: 2 + 3 atRandom and: 2 atRandom);
		add: (self tokenMinor: 2 atRandom and: 2 + 3 atRandom);
		add: (self tokenMinor: 2 atRandom and: 2 + 3 atRandom);
		add: (self tokenMinor: (n := 5 atRandom) and: n).
	activity :=  QuizMorph 
		illustration: (Stoa bag addAll: 3 redBall, 5 greenBall)
		proposals:  quizData. 

	question := 'Follow the example and select the bags containing less red balls than green balls.' translated.
	^ EtayageStep 
		board: PluggableBoard  
		method: #question:activity:isSuccess:showErrors:showSolution:
		arguments: {
			question. 
			activity.
			[activity testSuccessAnswer].
			[activity showErrors].
			[activity showSolution]}	! !

!EtayageNumber1 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/28/2014 17:21'!
instanciateStep4
	| quizData n activity |
	quizData := OrderedCollection new.
	quizData add: (self glassEqual:  (n := 5 atRandom) and: n);
		add: (self glassEqual: 2 + 3 atRandom and: 2 atRandom);
		add: (self glassEqual: 2 atRandom and: 2 + 3 atRandom);
		add: (self glassEqual: (n := 4  atRandom) and: n).
	activity :=  QuizMorph 
		illustration: (Stoa table addAll: (n := 4 atRandom) glass, n plate)
		proposals:  quizData. 
		
	question := 'Follow the example and select the tables containing the same number of glasses and plates.' translated.
	^ EtayageStep 
		board: PluggableBoard  
		method: #question:activity:isSuccess:showErrors:showSolution:
		arguments: {
			question. 
			activity.
			[activity testSuccessAnswer].
			[activity showErrors].
			[activity showSolution]}! !

!EtayageNumber1 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/17/2014 16:14'!
instanciateStep5
	| quizData n activity |
	quizData := OrderedCollection new.
	quizData add: (self glassSuperior: 2 + 3 atRandom and: 2 atRandom);
		add: (self glassSuperior: 3 + 2 atRandom and: 3 atRandom);
		add: (self glassSuperior: 2 atRandom and: 2 + 3 atRandom);
		add: (self glassSuperior: (n := 5 atRandom) and: n).
	activity :=  QuizMorph 
		illustration: (Stoa table addAll: 3 glass, 1 plate)
		proposals:  quizData. 

	question := 'Follow the example and select the tables containing more glasses than plates.' translated.
	^ EtayageStep 
		board: PluggableBoard  
		method: #question:activity:isSuccess:showErrors:showSolution:
		arguments: {
			question. 
			activity.
			[activity testSuccessAnswer].
			[activity showErrors].
			[activity showSolution]}! !

!EtayageNumber1 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/17/2014 16:14'!
instanciateStep6
	| quizData n activity |
	quizData := OrderedCollection new.
	quizData add: (self glassMinor: 2 + 3 atRandom and: 2 atRandom);
		add: (self glassMinor: 2 atRandom and: 2 + 3 atRandom);
		add: (self glassMinor: 2 atRandom and: 2 + 3 atRandom);
		add: (self glassMinor: (n := 5 atRandom) and: n).
	activity :=  QuizMorph 
		illustration: (Stoa table addAll: 3 glass, 5 plate)
		proposals:  quizData. 

	question := 'Follow the example and select the tables containing less glasses than plates.' translated.
	^ EtayageStep 
		board: PluggableBoard  
		method: #question:activity:isSuccess:showErrors:showSolution:
		arguments: {
			question. 
			activity.
			[activity testSuccessAnswer].
			[activity showErrors].
			[activity showSolution]}! !

!EtayageNumber1 methodsFor: 'step creation' stamp: 'HilaireFernandes 10/24/2014 18:12'!
tokenEqual: a and: b
"generate proposal token a, token b, a = b"
	^ Array 
		with: (Stoa bag addAll: a redBall, b greenBall) 
		with: a = b! !

!EtayageNumber1 methodsFor: 'step creation' stamp: 'HilaireFernandes 10/24/2014 18:12'!
tokenMinor: a and: b
"generate proposal token a, token b, a < b"
	^ Array 
		with: (Stoa bag addAll: a redBall, b greenBall) 
		with: a < b! !

!EtayageNumber1 methodsFor: 'step creation' stamp: 'HilaireFernandes 10/24/2014 18:12'!
tokenSuperior: a and: b
"generate proposal token a, token b, a > b"
	^ Array 
		with: (Stoa bag addAll: a redBall, b greenBall) 
		with: a > b! !

Etayage subclass: #EtayageNumber10
	instanceVariableNames: 'numbers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber10 commentStamp: '<historical>' prior: 0!
Target and arrow, write points from 0 to 5!

!EtayageNumber10 class methodsFor: 'accessing' stamp: 'HilaireFernandes 1/29/2014 15:40'!
description
	^ 'Write numbers between 0 and 5.' translated! !

!EtayageNumber10 class methodsFor: 'accessing' stamp: 'HilaireFernandes 5/18/2014 11:55'!
iconNameOrMorph
	^ Path * 'misc' / 'target.png'! !

!EtayageNumber10 class methodsFor: 'accessing' stamp: 'HilaireFernandes 1/29/2014 15:01'!
myCategory
	^ 'Numbers - The number 0' translated! !

!EtayageNumber10 methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 1/29/2014 20:20'!
initialize
	question := 'Follow the example and select the right number bellow.' translated.
	numbers := #(0 1 3 4 5) shuffled.
	super initialize.! !

!EtayageNumber10 methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 1/29/2014 15:28'!
instanciateStep1
	^ self stepTemplate: 1! !

!EtayageNumber10 methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 1/29/2014 15:28'!
instanciateStep2
	^ self stepTemplate: 2! !

!EtayageNumber10 methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 1/29/2014 15:28'!
instanciateStep3
	^ self stepTemplate: 3! !

!EtayageNumber10 methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 1/29/2014 15:28'!
instanciateStep4
	^ self stepTemplate: 4! !

!EtayageNumber10 methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 1/29/2014 15:28'!
instanciateStep5
	^ self stepTemplate: 5! !

!EtayageNumber10 methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 1/29/2014 15:38'!
stepTemplate: index
| illustration activity target |
	target := Stoa target positionning: #topLeft;
		addMorph: Stoa arrow at: #point2; 
		yourself.
	illustration := IllustratedTextMorph illustration: target of: 2.
	illustration color: Stoa illustrationColor.

	target := Stoa target positionning: #topLeft;
		addMorph: Stoa arrow at: ('point', (numbers at: index) asString) asSymbol; 
		yourself.
	activity := IllustratedTextMorph illustration:  target	of: (NumberSliderMorph value: 6 min: 0 max: 6).
	
	^ EtayageStep 
		board: PluggableBoard
		method:  #question:illustration:activity:isSuccess:showErrors:showSolution:
		arguments: { 
			question.
			illustration.
			activity.
			[ activity stringMorph value = (numbers at: index)].
			[ activity stringMorph value = (numbers at: index) 
				ifTrue: [ activity color: Color transparent ]
				ifFalse: [ activity color: Stoa wrongColor ] ].
			[ activity stringMorph value: (numbers at: index) ]
		 }		
	! !

Etayage subclass: #EtayageNumber11
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber11 class methodsFor: 'accessing' stamp: 'HilaireFernandes 5/19/2014 22:52'!
background
	^ Stoa getBackground: 'backgroundRoad.jpg'! !

!EtayageNumber11 class methodsFor: 'accessing' stamp: 'HilaireFernandes 5/28/2014 17:12'!
description
	^ 'Associate two collections with less than 5 elements.' translated! !

!EtayageNumber11 class methodsFor: 'accessing' stamp: 'HilaireFernandes 5/18/2014 11:55'!
iconNameOrMorph
	^ Path * 'vehicles' / 'cabriolet2places.png'! !

!EtayageNumber11 class methodsFor: 'accessing' stamp: 'HilaireFernandes 5/17/2014 16:03'!
myCategory
	^ 'Numbers - Compare collections' translated! !

!EtayageNumber11 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/18/2014 11:15'!
instanciateStep1
	^ self instanciateStepFill: Stoa cabriolet2places with: 2 occuped: 0! !

!EtayageNumber11 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/18/2014 11:34'!
instanciateStep2
	^ self instanciateStepFit: Stoa cabriolet2places with: 2 occuped: 0! !

!EtayageNumber11 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/18/2014 11:15'!
instanciateStep3
	^ self instanciateStepFill: Stoa cabriolet5places with: 5 occuped: 0! !

!EtayageNumber11 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/18/2014 11:34'!
instanciateStep4
	^ self instanciateStepFit: Stoa cabriolet5places  with: 5 occuped: 0! !

!EtayageNumber11 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/28/2014 17:14'!
instanciateStepFill: cabrioletMorph with: capacity occuped: occupedSeat
	| quizData activity n freeSeat |
	quizData := OrderedCollection new.
	freeSeat := capacity - occupedSeat.
	quizData add: (Array 
		with: (Stoa cloud addAll: freeSeat person)
		with: true) .
	3 timesRepeat: [ 
		quizData add: (Array 
			with: (Stoa cloud addAll: (n := (3 + freeSeat) atRandom) person)
			with: n = freeSeat)].
	activity := QuizMorph 
		illustration: cabrioletMorph
		proposals: quizData.
	question := 'Select which groups of people to fill the car with.' translated.
	^ EtayageStep 
		board: PluggableBoard  
		method: #question:activity:isSuccess:showErrors:showSolution:
		arguments: {
			question. 
			activity.
			[activity testSuccessAnswer].
			[activity showErrors].
			[activity showSolution]}


! !

!EtayageNumber11 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/28/2014 17:14'!
instanciateStepFit: cabrioletMorph with: capacity occuped: occupedSeat
	| quizData activity n freeSeat|
	quizData := OrderedCollection new.
	"pick up 1 or 2 right answers"
	freeSeat := capacity - occupedSeat.
	((1 to: freeSeat) asArray shuffled first: (2 min: freeSeat)) do: [ :i  | quizData add: (Array 
		with: (Stoa cloud addAll: i person)
		with: true)].

	"2 or 3 random proposals, right or wrong"
	4 - (freeSeat min: 2 max: 1) timesRepeat: [ 
		quizData add: (Array 
			with: (Stoa cloud addAll: (n := (3 + freeSeat) atRandom) person)
			with: n <= freeSeat)].
		
	activity := QuizMorph 
		illustration: cabrioletMorph 
		proposals: quizData.
	question := 'Select which groups of people you can fit in the car.' translated.
	^ EtayageStep 
		board: PluggableBoard  
		method: #question:activity:isSuccess:showErrors:showSolution:
		arguments: {
			question. 
			activity.
			[activity testSuccessAnswer].
			[activity showErrors].
			[activity showSolution]}! !

EtayageNumber11 subclass: #EtayageNumber12
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber12 class methodsFor: 'accessing' stamp: 'HilaireFernandes 5/28/2014 17:16'!
description
	^ 'Fill a collection with less than 5 elements.' translated! !

!EtayageNumber12 class methodsFor: 'accessing' stamp: 'HilaireFernandes 5/18/2014 11:55'!
iconNameOrMorph
	^ Path * 'vehicles' / 'cabriolet5places.png'! !

!EtayageNumber12 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/18/2014 11:47'!
instanciateStep1
	^ self instanciateStepFill: (Stoa cabriolet5places addAll: 4 person) with: 5 occuped: 4! !

!EtayageNumber12 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/18/2014 11:47'!
instanciateStep2
	^ self instanciateStepFill: (Stoa cabriolet5places addAll: 3 person) with: 5 occuped: 3! !

!EtayageNumber12 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/18/2014 11:47'!
instanciateStep3
	^ self instanciateStepFill: (Stoa cabriolet5places addAll: 2 person) with: 5 occuped: 2! !

!EtayageNumber12 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/18/2014 11:47'!
instanciateStep4
	^ self instanciateStepFill: (Stoa cabriolet5places addAll: 1 person) with: 5 occuped: 1! !

EtayageNumber11 subclass: #EtayageNumber13
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber13 class methodsFor: 'accessing' stamp: 'HilaireFernandes 5/28/2014 17:17'!
description
	^ 'Complete a collection with less than 5 elements.' translated! !

!EtayageNumber13 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/18/2014 11:58'!
instanciateStep1
	^ self instanciateStepFit: (Stoa cabriolet5places addAll: 4 person) with: 5 occuped: 4! !

!EtayageNumber13 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/18/2014 11:58'!
instanciateStep2
	^ self instanciateStepFit: (Stoa cabriolet5places addAll: 3 person) with: 5 occuped: 3! !

!EtayageNumber13 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/18/2014 11:58'!
instanciateStep3
	^ self instanciateStepFit: (Stoa cabriolet5places addAll: 2 person) with: 5 occuped: 2! !

!EtayageNumber13 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/18/2014 11:58'!
instanciateStep4
	^ self instanciateStepFit: (Stoa cabriolet5places addAll: 1 person) with: 5 occuped: 1! !

Etayage subclass: #EtayageNumber14
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber14 class methodsFor: 'accessing' stamp: 'HilaireFernandes 5/28/2014 17:19'!
description
	^ 'Count and write numbers between 1 and 5 in the table.' translated! !

!EtayageNumber14 class methodsFor: 'accessing' stamp: 'HilaireFernandes 5/27/2014 15:49'!
myCategory
	^ 'Numbers - 1 to 5' translated! !

!EtayageNumber14 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/27/2014 21:23'!
instanciateStep1
	^ self instanciateStep: #( 2 3 1 2) shuffled ! !

!EtayageNumber14 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/27/2014 21:23'!
instanciateStep2
	^ self instanciateStep: #( 4 2 1 2) shuffled ! !

!EtayageNumber14 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/27/2014 21:24'!
instanciateStep3
	^ self instanciateStep: #( 4 3 1 2) shuffled ! !

!EtayageNumber14 methodsFor: 'step creation' stamp: 'HilaireFernandes 5/27/2014 21:24'!
instanciateStep4
	^ self instanciateStep: #( 4 2 2 2) shuffled ! !

!EtayageNumber14 methodsFor: 'step creation' stamp: 'HilaireFernandes 6/7/2014 15:58'!
instanciateStep: items
| decoratedTable table |

	decoratedTable := Stoa table addAll: items first glass, items second coffeeCup, items third spoon, items fourth plate.
	table := SimpleTableMorph for: { 
		{Stoa glass. Stoa coffeeCup. Stoa spoon.  Stoa plate}.
		{NumberSliderMorph value: 6 min: 1 max: 6. NumberSliderMorph value: 6 min: 1 max: 6. 
			NumberSliderMorph value: 6 min: 1 max: 6.NumberSliderMorph value: 6 min: 1 max: 6. }
		 }.
	table cellGap: 10; border: 2.
	1 to: 4 do: [ :i | table cellColor: Color lightGreen at: i@1].
	question := 'Count and select the right numbers in the table.' translated.
	^ EtayageStep
		board: PluggableBoard
		method: #question:illustration:activity:isSuccess:showErrors:showSolution:
		arguments: { 
			question.
			decoratedTable.
			table.
			Array 
				with: [(table contentAt: 1@2) value = items first] 
				with: [(table contentAt: 2@2) value = items second]  
				with: [(table contentAt: 3@2) value = items third] 
				with: [(table contentAt: 4@2) value = items fourth].
			[ | cell |
			1 to: 4 do: [ :i | 
				cell := table cellAt: i@2.
				cell content value = (items at: i)
					ifTrue: [ cell color: Color white ] ifFalse: [ cell color: Stoa wrongColor]]].
			[1 to: 4 do: [:i | (table contentAt: i@2) value: (items at: i)] ]		
		 }! !

Etayage subclass: #EtayageNumber15
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber15 class methodsFor: 'accessing' stamp: 'HilaireFernandes 6/8/2014 12:42'!
description 
	^ 'Count letters and write numbers between 0 and 5.' translated! !

!EtayageNumber15 class methodsFor: 'accessing' stamp: 'HilaireFernandes 6/7/2014 11:48'!
myCategory
	^ 'Numbers - The number 0' translated! !

!EtayageNumber15 methodsFor: 'step creation' stamp: 'HilaireFernandes 6/8/2014 14:23'!
giveSomeLetters: amplitude
	| letters someLetters myLetters|
	myLetters := {'a' translated. 'b' translated. 'c' translated. 'h' translated. 'm' translated. 'p' translated. 'r' translated. 's' translated. 't' translated}.
	someLetters := myLetters shuffled first: 5.
	letters := someLetters collect: [ :aLetter |	Array with: aLetter with: 2 atRandom + amplitude].
	(letters at: 5) at: 2 put: 0. "We want one with 0"
	^ letters shuffled "just to make the 0 not always in last position"! !

!EtayageNumber15 methodsFor: 'step creation' stamp: 'HilaireFernandes 6/7/2014 17:42'!
instanciateStep1
	^ self instanciateStep: (self giveSomeLetters: 0)! !

!EtayageNumber15 methodsFor: 'step creation' stamp: 'HilaireFernandes 6/7/2014 17:42'!
instanciateStep2
	^ self instanciateStep: (self giveSomeLetters: 1)! !

!EtayageNumber15 methodsFor: 'step creation' stamp: 'HilaireFernandes 6/7/2014 17:42'!
instanciateStep3
	^ self instanciateStep: (self giveSomeLetters: 2)! !

!EtayageNumber15 methodsFor: 'step creation' stamp: 'HilaireFernandes 6/7/2014 17:42'!
instanciateStep4
	^ self instanciateStep: (self giveSomeLetters: 3)! !

!EtayageNumber15 methodsFor: 'step creation' stamp: 'HilaireFernandes 6/7/2014 17:48'!
instanciateStep: letters
	|letterCloud table row1 row2|
	row1 := OrderedCollection new.
	row2 := OrderedCollection new.
	letterCloud := Stoa largeCloud.
	letters do: [ :each | |morph|
		morph := (Stoa stringMorph: each first) font: (Stoa textFontOfSize: (Stoa scale: 80)).
		each second timesRepeat: [ letterCloud add: morph copy].
		row1 add: morph.
		row2 add: (NumberSliderMorph value: 6 min: 0 max: 6)].
	table := SimpleTableMorph for: {row1. row2}.
	table cellGap: 10; border: 2.
	1 to: letters size do: [ :i | table cellColor: Color lightGreen at: i@1].
	question := 'Count the letters, then write the number.' translated.
	^ EtayageStep
		board: PluggableBoard
		method: #question:illustration:activity:isSuccess:showErrors:showSolution:
		arguments: { 
			question.
			letterCloud.
			table.
			Array
				with: [(table contentAt: 1@2) value = letters first second]
				with: [(table contentAt: 2@2) value = letters second second]
				with: [(table contentAt: 3@2) value = letters third second]
				with: [(table contentAt: 4@2) value = letters fourth second]
				with: [(table contentAt: 5@2) value = letters fifth second].
			[ | cell |
			1 to: 5 do: [ :i | 
				cell := table cellAt: i@2.
				cell content value = (letters at: i) second
					ifTrue: [ cell color: Color white ] ifFalse: [ cell color: Stoa wrongColor]]].
			[1 to: 5 do: [:i | (table contentAt: i@2) value: (letters at: i) second] ]	
		 }! !

Etayage subclass: #EtayageNumber16
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber16 class methodsFor: 'accessing' stamp: 'HilaireFernandes 6/8/2014 15:39'!
description
	^ 'Count objects and report it in a table.' translated! !

!EtayageNumber16 class methodsFor: 'accessing' stamp: 'HilaireFernandes 6/8/2014 11:09'!
myCategory
	^ 'Numbers - The number 0' translated! !

!EtayageNumber16 methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 7/26/2014 13:30'!
fillTargets: targets answers: answers in: container with: items
	items do: [ :each |
		container addAll: (each second perform: each first).
		targets add: ((Stoa stringMorphLarge: each second)).
		answers add: (1 perform: each first)].
! !

!EtayageNumber16 methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 6/8/2014 15:34'!
giveFromItems: myItems upTo: max with: amplitude
	| someItems items quantities |
	someItems := myItems shuffled first: max.
	quantities := #(3 2 1 0).
	items := someItems collectWithIndex: [:anItem :index| Array with: anItem with: (quantities at: index) + amplitude].
	(items at: someItems size) at: 2 put: 0.
	^ items shuffled! !

!EtayageNumber16 methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 10/24/2014 18:13'!
giveSomeBalls: amplitude
	^ self 
		giveFromItems: #(#redBall #blueBall #yellowBall #blackBall #greenBall #orangeBall)
		upTo: 4
		with: amplitude 
	! !

!EtayageNumber16 methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 6/8/2014 14:56'!
giveSomeTableItems: amplitude
	^ self 
		giveFromItems: #(#coffeeCup #glass #plate #spoon #fork #knife)
		upTo: 3
		with: amplitude 
	! !

!EtayageNumber16 methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 6/8/2014 14:44'!
instanciateBagStep: amplitude
	| bag balls targets answers|
	targets := OrderedCollection new.
	answers := OrderedCollection new.
	balls :=self giveSomeBalls: amplitude.
	bag := Stoa bag.
	self fillTargets: targets answers: answers in: bag with: balls.
	question := 'Observe the bag and associate each ball with its number.' translated.
	^ EtayageStep
		board: BoardMatch
		method: #question:illustration:targets:answers:
		arguments: {question. bag. targets. answers}! !

!EtayageNumber16 methodsFor: 'step creation' stamp: 'HilaireFernandes 6/8/2014 15:35'!
instanciateStep1
	^ self instanciateTableStep: 1! !

!EtayageNumber16 methodsFor: 'step creation' stamp: 'HilaireFernandes 6/8/2014 15:35'!
instanciateStep2
	^ self instanciateTableStep: 2! !

!EtayageNumber16 methodsFor: 'step creation' stamp: 'HilaireFernandes 6/8/2014 14:49'!
instanciateStep3
	^ self instanciateBagStep: 2! !

!EtayageNumber16 methodsFor: 'step creation' stamp: 'HilaireFernandes 6/8/2014 14:49'!
instanciateStep4
	^ self instanciateBagStep: 3! !

!EtayageNumber16 methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 6/8/2014 14:45'!
instanciateTableStep: amplitude
	| table items targets answers|
	targets := OrderedCollection new.
	answers := OrderedCollection new.
	items :=self giveSomeTableItems: amplitude.
	table := Stoa table.
	self fillTargets: targets answers: answers in: table with: items.
	question := 'Observe the table and associate each items with its number.' translated.
	^ EtayageStep
		board: BoardMatch
		method: #question:illustration:targets:answers:
		arguments: {question. table. targets. answers}! !

Etayage subclass: #EtayageNumber17
	instanceVariableNames: 'numbers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber17 class methodsFor: 'accessing' stamp: 'HilaireFernandes 7/28/2014 11:03'!
description
		^ 'Compare quantites represented as cube towers.' translated! !

!EtayageNumber17 class methodsFor: 'accessing' stamp: 'HilaireFernandes 7/26/2014 12:51'!
iconNameOrMorph
	^ Path * 'shapes' / 'blueCube.png'! !

!EtayageNumber17 class methodsFor: 'accessing' stamp: 'HilaireFernandes 7/27/2014 23:11'!
myCategory
	^ 'Numbers - Compare quantities less than or equal to 5' translated! !

!EtayageNumber17 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 7/23/2014 11:12'!
initialize
	numbers := #(3 4 5) shuffled.
	super initialize! !

!EtayageNumber17 methodsFor: 'step creation' stamp: 'HilaireFernandes 7/23/2014 12:29'!
instanciateStep1
	| illustration basket quantity|
	question := 'Drag a red cube tower longer than the blue one.' translated.
	illustration := Stoa stackBlueCube: (quantity := numbers first).
	basket := Array new: 5.
	1 to: 5 do: [ :n | basket at: n put: (Stoa stackRedCube: n)].
	^ EtayageStep 
		board: BoardBlockMatch
		method: #question:basket:targets:answers:listDirection:
		arguments: { 
			question. 
			basket.  
			{ {illustration. '[self count = 1 and: [self firstItem model quantity > {1}]]' format: {quantity}} }. 
			{ {(#redCube, (quantity + 1) asString) asSymbol} }.
			#leftToRight
		}! !

!EtayageNumber17 methodsFor: 'step creation' stamp: 'HilaireFernandes 7/23/2014 12:30'!
instanciateStep2
	| illustration basket quantity |
	question := 'Drag a red cube tower with the same size as the blue one.' translated.
	illustration := Stoa stackBlueCube: (quantity := numbers second).
	basket := Array new: 5.
	1 to: 5 do: [ :n | basket at: n put: (Stoa stackRedCube: n)].
	^ EtayageStep 
		board: BoardBlockMatch
		method: #question:basket:targets:answers:listDirection:
		arguments: { 
			question. 
			basket.  
			{ {illustration. '[self count = 1 and: [self firstItem model quantity = {1}]]' format: {quantity}} }. 
			{ {(#redCube, quantity asString) asSymbol} }.
			#leftToRight
		}! !

!EtayageNumber17 methodsFor: 'step creation' stamp: 'HilaireFernandes 7/23/2014 12:31'!
instanciateStep3
	| illustration basket quantity |
	question := 'Drag a red cube tower shorter than the blue one.' translated.
	illustration := Stoa stackBlueCube: (quantity := numbers third).
	basket := Array new: 5.
	1 to: 5 do: [ :n | basket at: n put: (Stoa stackRedCube: n)].
	^ EtayageStep 
		board: BoardBlockMatch
		method: #question:basket:targets:answers:listDirection:
		arguments: { 
			question. 
			basket.  
			{ {illustration. '[self count = 1 and: [self firstItem model quantity < {1}]]' format: {quantity}} }. 
			{ {(#redCube, (quantity - 1) asString) asSymbol} }.
			#leftToRight
		}! !

!EtayageNumber17 methodsFor: 'step creation' stamp: 'HilaireFernandes 7/23/2014 13:02'!
instanciateStep4
	| illustration basket answers quantity|
	question := 'Drag all the red cube towers longer than the blue one.' translated.
	illustration := Stoa stackBlueCube: (quantity := numbers first).
	basket := Array new: 5.
	1 to: 5 do: [ :n | basket at: n put: (Stoa stackRedCube: n)].
	answers := OrderedCollection new.
	quantity + 1 to: 5 do: [ :n | answers add: ((#redCube, n asString) asSymbol)].
	^ EtayageStep 
		board: BoardBlockMatch
		method: #question:basket:targets:answers:listDirection:
		arguments: { 
			question. 
			basket.  
			{ {illustration. '[self equals: {1}]' format: {answers asArray}} }. 
			{ answers }.
			#leftToRight
		}! !

!EtayageNumber17 methodsFor: 'step creation' stamp: 'HilaireFernandes 7/23/2014 13:05'!
instanciateStep5
	| illustration basket answers quantity|
	question := 'Drag all the red cube towers shorter than the blue one.' translated.
	illustration := Stoa stackBlueCube: (quantity := numbers first).
	basket := Array new: 5.
	1 to: 5 do: [ :n | basket at: n put: (Stoa stackRedCube: n)].
	answers := OrderedCollection new.
	1 to: quantity - 1 do: [ :n | answers add: ((#redCube, n asString) asSymbol)].
	^ EtayageStep 
		board: BoardBlockMatch
		method: #question:basket:targets:answers:listDirection:
		arguments: { 
			question. 
			basket.  
			{ {illustration. '[self equals: {1}]' format: {answers asArray}} }. 
			{ answers }.
			#leftToRight
		}! !

Etayage subclass: #EtayageNumber18
	instanceVariableNames: 'couples'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber18 class methodsFor: 'accessing' stamp: 'HilaireFernandes 7/28/2014 11:08'!
description
		^ 'Compare quantites represented as dice.' translated! !

!EtayageNumber18 class methodsFor: 'accessing' stamp: 'HilaireFernandes 7/24/2014 16:06'!
iconNameOrMorph
	^ DiceMorph example! !

!EtayageNumber18 class methodsFor: 'accessing' stamp: 'HilaireFernandes 7/27/2014 23:11'!
myCategory
	^ 'Numbers - Compare quantities less than or equal to 5' translated! !

!EtayageNumber18 methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 7/24/2014 18:17'!
initialize
| n |
	couples := { 
	{n := 2 atRandom. n + (6 - n) atRandom}. 
	{n := 4 atRandom.  n + (6 - n) atRandom}.
	{n := 2 atRandom. n + (6 - n) atRandom} reverse. 
	{n := 4 atRandom.  n + (6 - n) atRandom} reverse}.

	super initialize! !

!EtayageNumber18 methodsFor: 'step creation' stamp: 'HilaireFernandes 7/27/2014 16:18'!
instanciateStep1
	|  morphs  |
	question := 'Follow the example and select the dice with the greatest value.' translated.
	morphs := Array 
		with: ((Stoa dice: 1) color: Color yellow)
		with: ((Stoa dice: 3) asStateMorph setState: #bordered) lock.
	^ self instanciateStep: couples first example: morphs! !

!EtayageNumber18 methodsFor: 'step creation' stamp: 'HilaireFernandes 7/27/2014 16:18'!
instanciateStep2
	|  morphs  |
	question := 'Follow the example and select the dice with the greatest value.' translated.
	morphs := Array 
		with: ((Stoa dice: 3) color: Color yellow)
		with: ((Stoa dice: 6) asStateMorph setState: #bordered) lock.
	^ self instanciateStep: couples second example: morphs! !

!EtayageNumber18 methodsFor: 'step creation' stamp: 'HilaireFernandes 7/27/2014 16:18'!
instanciateStep3
	|  morphs  |
	question := 'Follow the example and select the dice with the lowest value.' translated.
	morphs := Array 
		with: ((Stoa dice: 4) color: Color yellow)
		with: ((Stoa dice: 1) asStateMorph setState: #bordered) lock.
	^ self instanciateStep: couples third example: morphs! !

!EtayageNumber18 methodsFor: 'step creation' stamp: 'HilaireFernandes 7/27/2014 16:18'!
instanciateStep4
	|  morphs  |
	question := 'Follow the example and select the dice with the lowest value.' translated.
	morphs := Array 
		with: ((Stoa dice: 5) color: Color yellow)
		with: ((Stoa dice: 2) asStateMorph setState: #bordered) lock.
	^ self instanciateStep: couples fourth example: morphs! !

!EtayageNumber18 methodsFor: 'step creation' stamp: 'HilaireFernandes 7/24/2014 18:24'!
instanciateStep: couple example: exMorphs
	| illustration dices activity|
	illustration := Stoa decoratedBlank9 addAll: exMorphs.
	illustration addDropShadow; shadowColor: Stoa illustrationColor.
	"second dice: the one to select"
	dices := Array 
		with: (((Stoa dice: couple first ) color: Color cyan) asStateMorph states: #(#none #bordered)) 
		with: (((Stoa dice: couple second) color: Color magenta) asStateMorph states: #(#none #bordered)) . 
	activity := Stoa decoratedBlank9  addAll: dices.
	activity addDropShadow; shadowColor: Color transparent.
	^ EtayageStep 
		board: PluggableBoard
		method:  #question:illustration:activity:isSuccess:showErrors:showSolution:
		arguments: { 
			question.
			illustration.
			activity.
			[self isSuccessfull: dices].
			[(self isSuccessfull: dices) 
				ifTrue:  [activity shadowColor: Color transparent]
				ifFalse: [activity shadowColor: Stoa wrongColor] ].
			[activity shadowColor: Color transparent.
			dices second setState: #bordered.
			dices first setState: #none]
		 }	! !

!EtayageNumber18 methodsFor: 'testing' stamp: 'HilaireFernandes 7/24/2014 18:24'!
isSuccessfull: dices
	^ dices second state == #bordered and: [ dices first state == #none ]! !

Etayage subclass: #EtayageNumber19
	instanceVariableNames: 'couples'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber19 class methodsFor: 'accessing' stamp: 'HilaireFernandes 8/6/2014 23:14'!
description
	^ 'Compare quantites represented as cube towers with <, = or >.' translated! !

!EtayageNumber19 class methodsFor: 'accessing' stamp: 'HilaireFernandes 7/26/2014 12:51'!
iconNameOrMorph
	^ Path * 'shapes' / 'redCube.png'! !

!EtayageNumber19 class methodsFor: 'accessing' stamp: 'HilaireFernandes 7/27/2014 23:11'!
myCategory
	^ 'Numbers - Compare quantities less than or equal to 5' translated! !

!EtayageNumber19 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 16:35'!
couples
| n |
	^ { 
	{ n := 2 atRandom. n + 3 atRandom }.
	{ n := 1 + 2 atRandom. n + 2 atRandom}.
	{ n := 2 atRandom. n + 3 atRandom } reverse.	
	{ n := 1 + 2 atRandom. n + 2 atRandom} reverse.
	{ n := 3 atRandom. n }.
	{ n := 3 + 2 atRandom. n }
	 } shuffled.! !

!EtayageNumber19 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 16:49'!
initialize
	question := self question.
	couples := self couples.
	super initialize! !

!EtayageNumber19 methodsFor: 'step creation' stamp: 'HilaireFernandes 7/26/2014 23:28'!
instanciateStep1
	^ self instanciateStep: couples first! !

!EtayageNumber19 methodsFor: 'step creation' stamp: 'HilaireFernandes 7/26/2014 23:28'!
instanciateStep2
	^ self instanciateStep: couples second! !

!EtayageNumber19 methodsFor: 'step creation' stamp: 'HilaireFernandes 7/26/2014 23:28'!
instanciateStep3
	^ self instanciateStep: couples third! !

!EtayageNumber19 methodsFor: 'step creation' stamp: 'HilaireFernandes 7/26/2014 23:28'!
instanciateStep4
	^ self instanciateStep: couples fourth ! !

!EtayageNumber19 methodsFor: 'step creation' stamp: 'HilaireFernandes 7/26/2014 23:28'!
instanciateStep5
	^ self instanciateStep: couples fifth  ! !

!EtayageNumber19 methodsFor: 'step creation' stamp: 'HilaireFernandes 7/26/2014 23:28'!
instanciateStep6
	^ self instanciateStep: couples sixth   ! !

!EtayageNumber19 methodsFor: 'step creation' stamp: 'HilaireFernandes 10/24/2014 16:32'!
instanciateStep: couple
	| composite rightAnswer wrongAnswers |
	couple first > couple second ifTrue: [ 
		rightAnswer := ' > '.
		wrongAnswers :=#(' = ' ' < ') ].
	couple first < couple second ifTrue: [ 
		rightAnswer := ' < '.
		wrongAnswers :=#(' = ' ' > ') ].
	couple first = couple second ifTrue: [ 
		rightAnswer := ' = '.
		wrongAnswers :=#(' > ' ' < ') ].

	composite := SimpleTableMorph for: { 
		{Stoa stackRedCube: couple first. 
		nil.
		Stoa stackRedCube: couple second}.
		{ Stoa stringMorphLarge: couple first.
		MatchCompositeAbstract targetPlug.
		Stoa stringMorphLarge: couple second}}.
	composite border: 0; cellGap: 10. 
		^ EtayageStep
			board: BoardMatch
			method: #question:composite:targets:answers:
			arguments: {
				question. 
				composite. 
				#(''). 
				{ {Stoa stringMorphLarge: rightAnswer } .
				  {Stoa stringMorphLarge: wrongAnswers first. Stoa stringMorphLarge: wrongAnswers second} }
			}! !

!EtayageNumber19 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 16:32'!
question
	^ 'Compare with <, = or >.' translated! !

EtayageNumber19 subclass: #EtayageNumber21
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber21 class methodsFor: 'accessing' stamp: 'HilaireFernandes 11/3/2014 10:36'!
description
	^ 'Compare quantites with <, = or >.' translated! !

!EtayageNumber21 class methodsFor: 'accessing' stamp: 'HilaireFernandes 8/7/2014 09:50'!
iconNameOrMorph
	^ self textPreview: '< = >'.! !

!EtayageNumber21 methodsFor: 'step creation' stamp: 'HilaireFernandes 11/3/2014 22:02'!
instanciateStep: couple
	| composite rightAnswer wrongAnswers plug|
	couple first > couple second ifTrue: [ 
		rightAnswer := ' > '.
		wrongAnswers :=#(' = ' ' < ') ].
	couple first < couple second ifTrue: [ 
		rightAnswer := ' < '.
		wrongAnswers :=#(' = ' ' > ') ].
	couple first = couple second ifTrue: [ 
		rightAnswer := ' = '.
		wrongAnswers :=#(' > ' ' < ') ].

	composite := AlignmentMorph inARow: { 
		Stoa stringMorphLarge: couple first.
		plug := MatchCompositeAbstract targetPlug.
		Stoa stringMorphLarge: couple second}.
	composite cellPositioning: #center; borderWidth: 0; cellInset: 15.
		^ EtayageStep
			board: BoardMatch
			method: #question:composite:targets:answers:
			arguments: {
				question. 
				composite. 
				#(''). 
				{ {Stoa stringMorphLarge: rightAnswer } .
				  {Stoa stringMorphLarge: wrongAnswers first. Stoa stringMorphLarge: wrongAnswers second} }
			}! !

EtayageNumber21 subclass: #EtayageNumber34
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber34 class methodsFor: 'accessing' stamp: 'HilaireFernandes 10/24/2014 16:40'!
myCategory
	^ 'Numbers - 6 and 7' translated! !

!EtayageNumber34 methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 10/24/2014 16:48'!
couples
| n |
	^ { 
	{ 0. 5 + 2 atRandom }.
	{ n := 3 + 2 atRandom. n + 2 atRandom}.
	{ n := 4 atRandom. n + 3 atRandom } reverse.	
	{ n := 3 + 2 atRandom. n + 2 atRandom} reverse.
	{ n := 5 + 2 atRandom. n }.
	{ n := 4 + 2 atRandom. n }
	 } shuffled.! !

EtayageNumber19 subclass: #EtayageNumber22
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber22 class methodsFor: 'accessing' stamp: 'HilaireFernandes 8/7/2014 10:00'!
description
	^ 'Write numbers in expressions with <, = or >. ' translated! !

!EtayageNumber22 class methodsFor: 'accessing' stamp: 'HilaireFernandes 8/7/2014 10:01'!
iconNameOrMorph
	^ self textPreview: '4 < ?'.! !

!EtayageNumber22 methodsFor: 'step creation' stamp: 'HilaireFernandes 8/7/2014 10:54'!
compareSymbolOf: couple
	| symbol |
	couple first > couple second
		ifTrue: [ symbol := #> ].
	couple first = couple second
		ifTrue: [ symbol := #= ].
	couple first < couple second
		ifTrue: [ symbol := #< ].
	^ symbol! !

!EtayageNumber22 methodsFor: 'step creation' stamp: 'HilaireFernandes 8/7/2014 11:21'!
instanciateStep: couple
	| symbol rowMorph numberMorph |
	symbol := self compareSymbolOf: couple.
	rowMorph := Stoa rowMorph.
	rowMorph
		addMorph: (Stoa stringMorphLarge: couple first printString , ' ' , symbol , ' ');
		addMorphBack: (numberMorph := NumberSliderMorph value: nil min: 0 max: 6).
	numberMorph
		sliderOrientation: #topToBottom;
		font: Stoa largeTextFont.
	^ EtayageStep
		board: PluggableBoard
		method: #question:activity:isSuccess:showErrors:showSolution:
		arguments:
			{question.
			rowMorph.
			[numberMorph value notNil and: [couple first perform: symbol with: numberMorph value]].
			[(numberMorph value notNil and: [couple first perform: symbol with: numberMorph value])
				ifTrue: [ numberMorph color: Color transparent ]
				ifFalse: [ numberMorph color: Stoa wrongColor ] ].
			[ numberMorph value: couple second ]}! !

!EtayageNumber22 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 16:31'!
question
	^ 'Write a number that fit the expression.' translated.! !

EtayageNumber22 subclass: #EtayageNumber23
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber23 class methodsFor: 'accessing' stamp: 'HilaireFernandes 8/7/2014 10:52'!
iconNameOrMorph
	^ self textPreview: '? > 3'.! !

!EtayageNumber23 methodsFor: 'step creation' stamp: 'HilaireFernandes 8/8/2014 21:50'!
instanciateStep: couple
	| symbol rowMorph numberMorph |
	symbol := self compareSymbolOf: couple.
	rowMorph := Stoa rowMorph.
	rowMorph
		addMorph:  (numberMorph := NumberSliderMorph value: nil min: 0 max: 6);
		addMorphBack: (Stoa stringMorphLarge: ' ' , symbol , ' ', couple second printString).
	numberMorph
		sliderOrientation: #topToBottom;
		font: Stoa largeTextFont.
	^ EtayageStep
		board: PluggableBoard
		method: #question:activity:isSuccess:showErrors:showSolution:
		arguments:
			{question.
			rowMorph.
			[numberMorph value notNil and: [numberMorph value perform: symbol with: couple second]].
			[(numberMorph value notNil and: [numberMorph value perform: symbol with: couple second])
				ifTrue: [ numberMorph color: Color transparent ]
				ifFalse: [ numberMorph color: Stoa wrongColor ] ].
			[ numberMorph value: couple first ]}! !

Etayage subclass: #EtayageNumber2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber2 commentStamp: '<historical>' prior: 0!
Build collections with quantities bellow 5.!

!EtayageNumber2 class methodsFor: 'accessing' stamp: 'HilaireFernandes 5/28/2014 17:22'!
description
	^ 'Build collections with less than 5 elements.' translated! !

!EtayageNumber2 class methodsFor: 'accessing' stamp: 'HilaireFernandes 5/18/2014 11:55'!
iconNameOrMorph
	^ Path * 'fruits' / 'apple.png'! !

!EtayageNumber2 class methodsFor: 'accessing' stamp: 'HilaireFernandes 1/22/2014 20:04'!
myCategory
	^ 'Numbers - Compare collections' translated! !

!EtayageNumber2 methodsFor: 'step creation' stamp: 'HilaireFernandes 6/8/2014 11:48'!
instanciateStep1
	| illustration n |
	question := 'Drag apples below to have more apples than oranges.' translated.
	illustration := Stoa decoratedBlank9 addAll: (n := 4 atRandom) orange.
	^ EtayageStep 
		board: BoardBlockMatch
		method: #question:basket:targets:answers:
		arguments: { 
			question. 
			(n + 3 atRandom) apple.  
			{ {illustration. '[(self count: #apple) > {1}]' format: {n}} }. 
			{Array new: n + 1 withAll: #apple} }! !

!EtayageNumber2 methodsFor: 'step creation' stamp: 'HilaireFernandes 6/8/2014 11:48'!
instanciateStep2
	| illustration n |
	question := 'Drag apples below to have fewer apples than bananas.' translated.
	illustration := Stoa decoratedBlank9 addAll: (n := 1+ 4 atRandom) banana.
	^ EtayageStep 
		board: BoardBlockMatch
		method: #question:basket:targets:answers:
		arguments: { 
			question. 
			(n + 3 atRandom) apple.  
			{ {illustration. '[(self count: #apple) < {1}]' format: {n}} }. 
			{Array new: n - 1 withAll: #apple} }! !

!EtayageNumber2 methodsFor: 'step creation' stamp: 'HilaireFernandes 6/8/2014 11:48'!
instanciateStep3
	| illustration n |
	question := 'Drag oranges below to have as many oranges and apples.' translated.
	illustration := Stoa decoratedBlank9 addAll: (n := 5 atRandom) apple.
	^ EtayageStep 
		board: BoardBlockMatch
		method: #question:basket:targets:answers:
		arguments: { 
			question. 
			(n + 3 atRandom) orange.  
			{ {illustration. '[(self count: #orange) = {1}]' format: {n}} }. 
			{Array new: n withAll: #orange} }! !

!EtayageNumber2 methodsFor: 'step creation' stamp: 'HilaireFernandes 6/8/2014 11:48'!
instanciateStep4
	| illustration answer n |
	question := 'Drag the apples and oranges below to have more apples than bananas and less oranges than bananas.' translated.
	illustration := Stoa decoratedBlank9 addAll: (n :=1 + 3 atRandom) banana.
	answer := OrderedCollection withAll: (Array new: n - 1 withAll: #orange).
	answer addAll: (Array new: n + 1 withAll: #apple).
	^ EtayageStep 
		board: BoardBlockMatch
		method: #question:basket:targets:answers:
		arguments: { 
			question. 
			(n + 3 atRandom) apple, (n + 3 atRandom) orange.  
			{ {illustration. '[ (self count: #apple) > {1} and: [(self count: #orange) < {1}] ]' format: {n}} }. 
			{answer }}! !

Etayage subclass: #EtayageNumber20
	instanceVariableNames: 'couples'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber20 class methodsFor: 'accessing' stamp: 'HilaireFernandes 8/5/2014 12:00'!
description
		^ 'Compare quantites represented as dice with <, = or >.' translated! !

!EtayageNumber20 class methodsFor: 'accessing' stamp: 'HilaireFernandes 8/5/2014 11:59'!
iconNameOrMorph
	^ DiceMorph example color: Color red! !

!EtayageNumber20 class methodsFor: 'accessing' stamp: 'HilaireFernandes 8/5/2014 11:58'!
myCategory
	^ 'Numbers - Compare quantities less than or equal to 5' translated! !

!EtayageNumber20 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 8/5/2014 12:03'!
initialize
| n |
	couples := { 
	{ n := 2 atRandom. n + 3 atRandom }.
	{ n := 1 + 2 atRandom. n + 2 atRandom}.
	{ n := 2 atRandom. n + 3 atRandom } reverse.	
	{ n := 1 + 2 atRandom. n + 2 atRandom} reverse.
	{ n := 3 atRandom. n }.
	{ n := 3 + 2 atRandom. n }
	 }.
	couples := couples shuffled.
	super initialize! !

!EtayageNumber20 methodsFor: 'step creation' stamp: 'HilaireFernandes 8/6/2014 00:21'!
instanciateStep1
	^ self instanciateStep: couples first! !

!EtayageNumber20 methodsFor: 'step creation' stamp: 'HilaireFernandes 8/6/2014 00:21'!
instanciateStep2
	^ self instanciateStep: couples second! !

!EtayageNumber20 methodsFor: 'step creation' stamp: 'HilaireFernandes 8/6/2014 00:21'!
instanciateStep3
	^ self instanciateStep: couples third! !

!EtayageNumber20 methodsFor: 'step creation' stamp: 'HilaireFernandes 8/6/2014 00:21'!
instanciateStep4
	^ self instanciateStep: couples fourth ! !

!EtayageNumber20 methodsFor: 'step creation' stamp: 'HilaireFernandes 8/6/2014 00:21'!
instanciateStep5
	^ self instanciateStep: couples fifth  ! !

!EtayageNumber20 methodsFor: 'step creation' stamp: 'HilaireFernandes 8/6/2014 00:21'!
instanciateStep6
	^ self instanciateStep: couples sixth   ! !

!EtayageNumber20 methodsFor: 'step creation' stamp: 'HilaireFernandes 8/6/2014 00:41'!
instanciateStep: couple 
| composite rightAnswer activity numberMorph1 numberMorph2 wrongAnswers |
	question := 'Write the numbers and compare with <, = or >.' translated.
	composite := SimpleTableMorph for: {
		{(Stoa dice: couple first) color: Color yellow.
		  nil.
		(Stoa dice: couple second) color: Color cyan}.
		{numberMorph1 := NumberSliderMorph value: 6 min: 0 max: 6.
		MatchCompositeAbstract targetPlug.
		numberMorph2 := NumberSliderMorph  value: 6 min: 0 max: 6}}.
	couple first > couple second ifTrue: [ 
		rightAnswer := ' > '.
		wrongAnswers :=#(' = ' ' < ') ].
	couple first < couple second ifTrue: [ 
		rightAnswer := ' < '.
		wrongAnswers :=#(' = ' ' > ') ].
	couple first = couple second ifTrue: [ 
		rightAnswer := ' = '.
		wrongAnswers :=#(' > ' ' < ') ].

	activity := MatchCompositeMorph 
		composite:	composite
		targets: #('')
		answers: {
		{Stoa stringMorphLarge: rightAnswer}.
		wrongAnswers collect: [:s | Stoa stringMorphLarge: s]}.
	^ EtayageStep 
		board: PluggableBoard
		method: #question:activity:isSuccess:showErrors:showSolution:
		arguments: { 
			question.
			activity.
			[ activity testSuccessAnswer and: [numberMorph1 value = couple first and: [numberMorph2 value = couple second]]].
			[activity showErrors.
			composite 
				cellColor: (numberMorph1 value = couple first 
					ifTrue: [Color white] ifFalse: [Stoa wrongColor])
				at: 1@2.
			composite 
				cellColor: (numberMorph2 value = couple second 
					ifTrue: [Color white] ifFalse: [Stoa wrongColor])
				at: 3@2].
			[activity showSolution.
			numberMorph1 value: couple first.
			numberMorph2 value: couple second.
			{1@2. 3@2} do: [:p |composite cellColor: Color white at: p]]}
		! !

Etayage subclass: #EtayageNumber3
	instanceVariableNames: 'numbers items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber3 commentStamp: '<historical>' prior: 0!
Numbers from 1 to 5.!

!EtayageNumber3 class methodsFor: 'accessing' stamp: 'HilaireFernandes 1/18/2014 21:24'!
description
	^ 'Count and write numbers between 1 and 5.' translated! !

!EtayageNumber3 class methodsFor: 'accessing' stamp: 'HilaireFernandes 1/22/2014 20:05'!
myCategory
	^ 'Numbers - 1 to 5' translated! !

!EtayageNumber3 methodsFor: 'step creation' stamp: 'HilaireFeranndes 3/23/2014 10:31'!
illustratedTextMorphFor: index
	^ IllustratedTextMorph 
		illustration:  (Stoa decoratedBlank9 addAll: ((numbers at: index) perform: (items at: index)))
		of: (NumberSliderMorph value: 6 min: 1 max: 6). 
! !

!EtayageNumber3 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 15:50'!
initialize
	numbers := self numbers.
	items := self items.
	question := self question.
	super initialize.
! !

!EtayageNumber3 methodsFor: 'step creation' stamp: 'HilaireFernandes 1/18/2014 21:06'!
instanciateStep1
		^ self stepTemplate: 1! !

!EtayageNumber3 methodsFor: 'step creation' stamp: 'HilaireFernandes 1/18/2014 21:06'!
instanciateStep2
		^ self stepTemplate: 2! !

!EtayageNumber3 methodsFor: 'step creation' stamp: 'HilaireFernandes 1/18/2014 21:06'!
instanciateStep3
		^ self stepTemplate: 3! !

!EtayageNumber3 methodsFor: 'step creation' stamp: 'HilaireFernandes 1/18/2014 21:06'!
instanciateStep4
		^ self stepTemplate: 4! !

!EtayageNumber3 methodsFor: 'step creation' stamp: 'HilaireFernandes 1/18/2014 21:06'!
instanciateStep5
		^ self stepTemplate: 5! !

!EtayageNumber3 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 15:49'!
items
	^ #(#apple #orange #banana #pear #walnut) shuffled.
! !

!EtayageNumber3 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 15:49'!
numbers
	^ (1 to: 5) asArray shuffled.
! !

!EtayageNumber3 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 15:49'!
question
	^ 'Count and select the right number bellow.' translated.! !

!EtayageNumber3 methodsFor: 'step creation' stamp: 'HilaireFeranndes 3/23/2014 10:31'!
stepTemplate: index
	| activity |
	activity := self illustratedTextMorphFor: index.	
	^ EtayageStep 
		board: PluggableBoard
		method: #question:activity:isSuccess:showErrors:showSolution:
		arguments: { 
			question.
			activity.
			[ activity stringMorph value = (numbers at: index)].
			[ activity stringMorph value = (numbers at: index) 
				ifTrue: [ activity color: Color transparent ]
				ifFalse: [ activity color: Stoa wrongColor ] ].
			[ activity stringMorph value: (numbers at: index) ]
	 }! !

EtayageNumber3 subclass: #EtayageNumber32
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber32 class methodsFor: 'accessing' stamp: 'HilaireFernandes 10/24/2014 15:55'!
description
	^ 'Count and write numbers between 1 and 7.' translated! !

!EtayageNumber32 class methodsFor: 'accessing' stamp: 'HilaireFernandes 10/24/2014 16:04'!
iconNameOrMorph
	^ Path * 'clothes' / 'hoodie.png'! !

!EtayageNumber32 class methodsFor: 'accessing' stamp: 'HilaireFernandes 10/24/2014 15:55'!
myCategory
	^ 'Numbers - 6 and 7' translated! !

!EtayageNumber32 methodsFor: 'step creation' stamp: 'HilaireFernandes 10/24/2014 15:59'!
illustratedTextMorphFor: index
	^ IllustratedTextMorph 
		illustration:  (Stoa decoratedBlank9 addAll: ((numbers at: index) perform: (items at: index)))
		of: (NumberSliderMorph value: 8 min: 1 max: 8). 
! !

!EtayageNumber32 methodsFor: 'initailize-release' stamp: 'HilaireFernandes 10/24/2014 15:57'!
items
	^ #(#blouse #hoodie #jacket #polo #tshirt) shuffled.
! !

!EtayageNumber32 methodsFor: 'initailize-release' stamp: 'HilaireFernandes 10/24/2014 15:57'!
numbers 
	| collection |
	collection := OrderedCollection with: 6 with: 7.
	collection addAll: (#(1 2 3 4 5) shuffled first: 3).
	^ collection shuffled
! !

EtayageNumber3 subclass: #EtayageNumber8
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber8 commentStamp: '<historical>' prior: 0!
Count and write numbers between 0 and 5.!

!EtayageNumber8 class methodsFor: 'accessing' stamp: 'HilaireFernandes 6/7/2014 11:38'!
description
	^ 'Count and write the number 0. Associate it to empty set.' translated! !

!EtayageNumber8 class methodsFor: 'accessing' stamp: 'HilaireFernandes 1/26/2014 16:40'!
myCategory
	^ 'Numbers - The number 0' translated! !

!EtayageNumber8 methodsFor: 'step creation' stamp: 'HilaireFeranndes 3/23/2014 10:31'!
illustratedTextMorphFor: index
	^ IllustratedTextMorph 
		illustration:  (Stoa decoratedBlank9 addAll: ((numbers at: index) perform: (items at: index)))
		of: (NumberSliderMorph value: 6 min: 0 max: 6). 
! !

!EtayageNumber8 methodsFor: 'step creation' stamp: 'HilaireFernandes 1/26/2014 16:53'!
instanciateStep6
	^ self stepTemplate: 6! !

!EtayageNumber8 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 18:13'!
items
	^ #(#redBall #orangeBall #blueBall #greenBall #yellowBall #blackBall) shuffled.
! !

!EtayageNumber8 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 15:52'!
numbers
	^ (0 to: 5) asArray shuffled.
! !

Etayage subclass: #EtayageNumber30
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber30 class methodsFor: 'accessing' stamp: 'HilaireFernandes 8/11/2014 10:24'!
description
	^ 'Count and associate a collection with its quantity.' translated! !

!EtayageNumber30 class methodsFor: 'accessing' stamp: 'HilaireFernandes 8/8/2014 22:20'!
myCategory
	^ 'Numbers - 6 and 7' translated! !

!EtayageNumber30 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 8/11/2014 10:25'!
initialize
	question := 'Drag each collection with its right number.' translated.
	super initialize! !

!EtayageNumber30 methodsFor: 'step creation' stamp: 'HilaireFernandes 8/11/2014 11:37'!
instanciateStep1
	^ self instanciateStep: #(5 6)! !

!EtayageNumber30 methodsFor: 'step creation' stamp: 'HilaireFernandes 8/11/2014 11:37'!
instanciateStep2
	^ self instanciateStep: #(6 7)! !

!EtayageNumber30 methodsFor: 'step creation' stamp: 'HilaireFernandes 8/11/2014 11:37'!
instanciateStep3
	^ self instanciateStep: #(5 7)! !

!EtayageNumber30 methodsFor: 'step creation' stamp: 'HilaireFernandes 8/11/2014 11:36'!
instanciateStep4
	^ self instanciateStep: #(5 6 7)! !

!EtayageNumber30 methodsFor: 'step creation' stamp: 'HilaireFernandes 8/11/2014 11:37'!
instanciateStep5
	^ self instanciateStep: #(6 7 5)! !

!EtayageNumber30 methodsFor: 'step creation' stamp: 'HilaireFernandes 8/11/2014 11:37'!
instanciateStep6
	^ self instanciateStep: #(5 7 6)! !

!EtayageNumber30 methodsFor: 'step creation' stamp: 'HilaireFernandes 8/11/2014 11:36'!
instanciateStep: triple
	| food targets answers |
	food := #(#bread #croissant #cupcake #friedEgg #misoSoup #muffin) shuffled.
	targets := Array with: (Stoa stringMorph: triple first) with: (Stoa stringMorph: triple second).
	answers := OrderedCollection new.
	answers 
		add: { 
			Stoa decoratedBlank10w addAll: (triple first perform: food first).
			Stoa decoratedBlank10w addAll: (triple first perform: food second)};
		add: { 
			Stoa decoratedBlank10w addAll: (triple second perform: food third).
			Stoa decoratedBlank10w addAll: (triple second perform: food fourth)}.
	triple size = 3 ifTrue: [ 
		answers add: { 
			Stoa decoratedBlank10w addAll: (triple third perform: food fifth).
			Stoa decoratedBlank10w addAll: (triple third perform: food sixth)}].
	^ EtayageStep
		board: BoardMatch 
		method: #question:targets:answers:
		arguments: {question. targets. answers}! !

Etayage subclass: #EtayageNumber4
	instanceVariableNames: 'numbers items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber4 commentStamp: '<historical>' prior: 0!
Build collection of objects from 1 to 5.!

EtayageNumber4 subclass: #EtayageNumber31
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber31 class methodsFor: 'accessing' stamp: 'HilaireFernandes 10/24/2014 11:59'!
description
	^ 'Build a collection between 0 and 7 objects.' translated! !

!EtayageNumber31 class methodsFor: 'accessing' stamp: 'HilaireFernandes 10/24/2014 11:59'!
myCategory
	^ 'Numbers - 6 and 7' translated! !

!EtayageNumber31 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 12:09'!
numbers 
	| collection |
	collection := OrderedCollection with: 0 with: 6 with: 7.
	collection addAll: (#(1 2 3 4 5) shuffled first: 2).
	^ collection shuffled
! !

!EtayageNumber4 class methodsFor: 'accessing' stamp: 'HilaireFernandes 5/28/2014 17:24'!
description
	^ 'Build a collection between 1 and 5 objects.' translated! !

!EtayageNumber4 class methodsFor: 'accessing' stamp: 'HilaireFernandes 1/22/2014 20:05'!
myCategory
	^ 'Numbers - 1 to 5' translated! !

!EtayageNumber4 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 12:04'!
initialize 
	numbers := self numbers.
	question := self question.
	items := self items.
	super initialize! !

!EtayageNumber4 methodsFor: 'step creation' stamp: 'HilaireFernandes 1/20/2014 17:04'!
instanciateStep1
	^ self stepTemplate: 1! !

!EtayageNumber4 methodsFor: 'step creation' stamp: 'HilaireFernandes 1/20/2014 17:13'!
instanciateStep2
	^ self stepTemplate: 2! !

!EtayageNumber4 methodsFor: 'step creation' stamp: 'HilaireFernandes 1/20/2014 17:13'!
instanciateStep3
	^ self stepTemplate: 3! !

!EtayageNumber4 methodsFor: 'step creation' stamp: 'HilaireFernandes 1/20/2014 17:13'!
instanciateStep4
	^ self stepTemplate: 4! !

!EtayageNumber4 methodsFor: 'step creation' stamp: 'HilaireFernandes 1/20/2014 17:13'!
instanciateStep5
	^ self stepTemplate: 5! !

!EtayageNumber4 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 18:13'!
items
	^ #(#greenBall #redBall #blackBall #blueBall #yellowBall) shuffled.
! !

!EtayageNumber4 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 12:03'!
numbers 
	^ (1 to: 5) asArray shuffled.
! !

!EtayageNumber4 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 12:04'!
question
	^  'Drag tokens bellow as indicated by the number.' translated.
! !

!EtayageNumber4 methodsFor: 'step creation' stamp: 'HilaireFernandes 6/8/2014 11:48'!
stepTemplate: n
	| quantity item |
	quantity := numbers at: n.
	item := items at: n.
	^ EtayageStep 
		board: BoardBlockMatch
		method: #question:basket:targets:answers:
		arguments: { 
			question. 
			(quantity + 4 atRandom) perform: item.  
			{ {Stoa stringMorph: quantity . '[(self count: {1}) = {2}]' format: {item printString. quantity}} }. 
			{Array new: quantity withAll: item} }! !

EtayageNumber4 subclass: #EtayageNumber7
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber7 commentStamp: '<historical>' prior: 0!
Build a collection of objects, between 0 and 5.!

!EtayageNumber7 class methodsFor: 'accessing' stamp: 'HilaireFernandes 1/26/2014 16:41'!
description
	^ 'Build a collection of objects, between 0 and 5.' translated! !

!EtayageNumber7 class methodsFor: 'accessing' stamp: 'HilaireFernandes 1/26/2014 15:31'!
myCategory
	^ 'Numbers - The number 0' translated! !

!EtayageNumber7 methodsFor: 'step creation' stamp: 'HilaireFernandes 1/26/2014 16:23'!
instanciateStep6
	^ self stepTemplate: 6! !

!EtayageNumber7 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 12:05'!
items
	^  #(#apple #orange #pear #banana #walnut #cherry) shuffled.
! !

!EtayageNumber7 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 12:05'!
numbers
	^ (0 to: 5) asArray shuffled.
! !

!EtayageNumber7 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 12:05'!
question
	^ 'Drag fruits bellow as indicated by the number.' translated.
! !

Etayage subclass: #EtayageNumber5
	instanceVariableNames: 'progressions shapes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber5 commentStamp: '<historical>' prior: 0!
Count one by one from 1 to 5.!

EtayageNumber5 subclass: #EtayageNumber33
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber33 class methodsFor: 'accessing' stamp: 'HilaireFernandes 10/24/2014 16:15'!
description
	^ 'Count one by one from 0 to 7.' translated! !

!EtayageNumber33 class methodsFor: 'accessing' stamp: 'HilaireFernandes 10/24/2014 16:21'!
iconNameOrMorph
	^ Path * 'decorations' / 'paper-frame2.png'! !

!EtayageNumber33 class methodsFor: 'accessing' stamp: 'HilaireFernandes 10/24/2014 16:15'!
myCategory
	^ 'Numbers - 6 and 7' translated! !

!EtayageNumber33 methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 10/24/2014 16:25'!
progressions
	^ #(
		#( #(3 4 nil nil) #(3 4 5 6))
		#( #(nil 5 nil 7) #(4 5 6 7))
		#( #(4 nil 6 nil) #(4 5 6 7))
		#( #(4 nil nil nil) #(4 5 6 7))
		#( #(nil 1 2 3 nil nil nil nil) #(0 1 2 3 4 5 6 7))
		). ! !

!EtayageNumber5 class methodsFor: 'accessing' stamp: 'HilaireFernandes 1/22/2014 15:10'!
description
	^ 'Count one by one from 1 to 5.' translated! !

!EtayageNumber5 class methodsFor: 'accessing' stamp: 'HilaireFernandes 1/22/2014 20:05'!
myCategory
	^ 'Numbers - 1 to 5' translated! !

!EtayageNumber5 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 16:10'!
initialize
	question := self question.
	shapes := self shapes.
	progressions := self progressions.
	super initialize.
! !

!EtayageNumber5 methodsFor: 'step creation' stamp: 'HilaireFernandes 1/22/2014 15:26'!
instanciateStep1
	^ self stepTemplate: 1! !

!EtayageNumber5 methodsFor: 'step creation' stamp: 'HilaireFernandes 1/22/2014 15:26'!
instanciateStep2
	^ self stepTemplate: 2! !

!EtayageNumber5 methodsFor: 'step creation' stamp: 'HilaireFernandes 1/22/2014 15:26'!
instanciateStep3
	^ self stepTemplate: 3! !

!EtayageNumber5 methodsFor: 'step creation' stamp: 'HilaireFernandes 1/22/2014 15:26'!
instanciateStep4
	^ self stepTemplate: 4! !

!EtayageNumber5 methodsFor: 'step creation' stamp: 'HilaireFernandes 1/22/2014 15:26'!
instanciateStep5
	^ self stepTemplate: 5! !

!EtayageNumber5 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 16:10'!
progressions
	^ #(
		#( #(nil 2 nil 4 nil) #(1 2 3 4 5))
		#(#(1 2 nil nil nil) #(1 2 3 4 5))
		#(#(1 nil 3 nil 5) #(1 2 3 4 5))
		#(#(nil nil nil 4 5) #(1 2 3 4 5))
		#(#(1 nil nil nil 5) #(1 2 3 4 5))
		) shuffled. ! !

!EtayageNumber5 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 16:08'!
question
	^ 'Select the right numbers in the collection bellow.' translated.! !

!EtayageNumber5 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 16:09'!
shapes
	^ {Color green . Color cyan. #memo . #note . Color yellow} shuffled.! !

!EtayageNumber5 methodsFor: 'step creation' stamp: 'HilaireFernandes 1/22/2014 15:30'!
stepTemplate: n
| activity |
	activity := ProgressionMorph 
		progression: (progressions at: n) first 
		min: (progressions at: n) second min
		max: (progressions at: n) second max 
		shape: (shapes at: n) 
		answers: (progressions at: n) second.
	
	^ EtayageStep
		board: PluggableBoard
		method: #question:activity:isSuccess:showErrors:showSolution:
		arguments: { 
			question.
			activity .
			[ activity testSuccessAnswer].
			[ activity showErrors ].
			[ activity showSolution ]
		 }! !

EtayageNumber5 subclass: #EtayageNumber9
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber9 commentStamp: '<historical>' prior: 0!
Count one by one from 0 to 5.!

!EtayageNumber9 class methodsFor: 'accessing' stamp: 'HilaireFernandes 1/27/2014 21:43'!
description
	^ 'Count one by one from 0 to 5.' translated! !

!EtayageNumber9 class methodsFor: 'accessing' stamp: 'HilaireFernandes 1/27/2014 21:56'!
myCategory
	^ 'Numbers - The number 0' translated! !

!EtayageNumber9 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 10/24/2014 16:11'!
progressions
	^ #(
		#( #(0 1 2 nil nil nil) #(0 1 2 3 4 5))
		#( #(nil 1 nil 3 nil 5) #(0 1 2 3 4 5))
		#( #(0 nil 2 nil 4 nil) #(0 1 2 3 4 5))
		#( #(5 4 3 nil nil nil) #(5 4 3 2 1 0))
		#( #(5 nil 3 nil 1 nil) #(5 4 3 2 1 0))
		). ! !

Etayage subclass: #EtayageNumber6
	instanceVariableNames: 'numbers items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iStoaXP-Gde1'!

!EtayageNumber6 commentStamp: '<historical>' prior: 0!
Build a collection with quantity between 1 and 5.!

!EtayageNumber6 class methodsFor: 'accessing' stamp: 'HilaireFernandes 5/3/2014 15:04'!
description
	^ 'Select and unselect objects to build a collection.' translated! !

!EtayageNumber6 class methodsFor: 'accessing' stamp: 'HilaireFernandes 1/22/2014 20:43'!
myCategory
	^ 'Numbers - 1 to 5' translated! !

!EtayageNumber6 methodsFor: 'initialize-release' stamp: 'HilaireFernandes 5/28/2014 17:29'!
initialize
	question := 'Like the example, select and unselect objects to match the number.' translated.
	numbers := #(1 2 4 5) shuffled.
	items := #(#apple #orange #banana #pear #walnut) shuffled.
	super initialize ! !

!EtayageNumber6 methodsFor: 'step creation' stamp: 'HilaireFernandes 1/24/2014 21:53'!
instanciateStep1
	^ self stepTemplate: 1! !

!EtayageNumber6 methodsFor: 'step creation' stamp: 'HilaireFernandes 1/24/2014 22:25'!
instanciateStep2
	^ self stepTemplate: 2! !

!EtayageNumber6 methodsFor: 'step creation' stamp: 'HilaireFernandes 1/24/2014 22:25'!
instanciateStep3
	^ self stepTemplate: 3! !

!EtayageNumber6 methodsFor: 'step creation' stamp: 'HilaireFernandes 1/24/2014 22:25'!
instanciateStep4
	^ self stepTemplate: 4! !

!EtayageNumber6 methodsFor: 'testing' stamp: 'HilaireFernandes 7/24/2014 16:50'!
isSuccessfull: activity 
| crossed bordered |
	bordered := activity illustration submorphs count: [ :each | each state ==  #bordered].
	crossed := activity illustration submorphs count: [ :each | each state ==  #crossed].
	^ bordered + crossed = activity illustration submorphCount and: [ bordered = activity stringMorph contents asInteger ]
! !

!EtayageNumber6 methodsFor: 'step creation' stamp: 'HilaireFernandes 7/24/2014 17:49'!
stepTemplate: n
	| illustration morphs activity |
	morphs := (2 + 3) perform: items first.
	morphs := morphs collectWithIndex: [:each :index | 
		each asStateMorph setState: (index <= 3 ifTrue: [#bordered] ifFalse: [#crossed])].
	illustration := IllustratedTextMorph 
		illustration: 	(Stoa decoratedBlank9 addAll: morphs) lock
		of: 3.
	illustration color: Stoa illustrationColor.
	
	morphs := (4 atRandom + numbers at: n) perform: (items at: n + 1).
	activity := IllustratedTextMorph 
		illustration:  (Stoa decoratedBlank9 addAll: (morphs collect: [:each | each asStateMorph]))
		of: (numbers at: n).
		
	^ EtayageStep 
		board: PluggableBoard
		method:  #question:illustration:activity:isSuccess:showErrors:showSolution:
		arguments: { 
			question.
			illustration.
			activity.
			[self isSuccessfull: activity].
			[(self isSuccessfull: activity) 
				ifTrue:  [activity color: Color transparent]
				ifFalse: [activity color: Stoa wrongColor] ].
			[activity color: Color transparent.
			activity illustration submorphs doWithIndex: [:morph : index |
				morph setState: (index <= (numbers at: n) ifTrue: [#bordered] ifFalse: [#crossed])] ]
		 }! !
